CREATE TABLE ACCOUNT
(ACCOUNT_ID	VARCHAR (10)	NOT NULL,
 NAME		VARCHAR (25)	NOT NULL,
 TYPE		VARCHAR (10)	NOT NULL,
 DESCRIPTION	VARCHAR (500)	NOT NULL,
 STATUS		VARCHAR (2)	NOT NULL,
 BALANCE	DECIMAL (10,2)	NOT NULL,
 OPEN_DATE	TIMESTAMP	NULL DEFAULT CURRENT_TIMESTAMP,
 CLOSE_DATE	TIMESTAMP	NULL DEFAULT NULL,
 CUSTOMER_ID	VARCHAR (9)	NOT NULL);

ALTER TABLE ACCOUNT
  ADD CONSTRAINT ACCOUNT_PK_ACCOUNT_ID
      PRIMARY KEY (ACCOUNT_ID);

ALTER TABLE ACCOUNT
  ADD CONSTRAINT ACCOUNT_FK_CUSTOMER_ID
      FOREIGN KEY (CUSTOMER_ID)
      REFERENCES CUSTOMER (CUSTOMER_ID);

ALTER TABLE ACCOUNT
  ADD CONSTRAINT ACCOUNT_CK_BALANCE
      CHECK (BALANCE >= 0);

ALTER TABLE ACCOUNT
  ADD CONSTRAINT ACCOUNT_UK_CUSTOMER_ID_TYPE UNIQUE (CUSTOMER_ID, TYPE);
     