create table acl_sid (
  id bigint identity(2000,1) not null primary key,
  principal bit not null,
  sid varchar(100) not null,
  constraint unique_uk_1 unique(sid,principal) );

create table acl_class (
  id bigint identity(2000,1) not null primary key,
  class varchar(100) not null,
  constraint unique_uk_2 unique(class) );

create table acl_object_identity (
  id bigint identity(2000,1) not null primary key,
  object_id_class bigint not null,
  object_id_identity bigint not null,
  parent_object bigint,
  owner_sid bigint not null,
  entries_inheriting bit not null,
  constraint unique_uk_3 unique(object_id_class,object_id_identity),
  constraint foreign_fk_1 foreign key(parent_object)references acl_object_identity(id),
  constraint foreign_fk_2 foreign key(object_id_class)references acl_class(id),
  constraint foreign_fk_3 foreign key(owner_sid)references acl_sid(id) );

create table acl_entry (
  id bigint identity(2000,1) not null primary key,
  acl_object_identity bigint not null,ace_order int not null,sid bigint not null,
  mask bigint not null,granting bit not null,audit_success bit not null,
  audit_failure bit not null,
  constraint unique_uk_4 unique(acl_object_identity,ace_order),
  constraint foreign_fk_4 foreign key(acl_object_identity)
      references acl_object_identity(id),
  constraint foreign_fk_5 foreign key(sid) references acl_sid(id) );
